TinkOptions = {}
local myFrame = CreateFrame("frame");
myFrame:SetScript("OnEvent", function(self, event)
	if event == "PLAYER_ENTERING_WORLD" then
		usable, nomana = IsUsableSpell("Engineering")
		if not usable then
			TinkFrame:Hide()
		else
			DEFAULT_CHAT_FRAME:AddMessage("Tinker 404 (Engineering not found)")
		end
	end
	if event == "VARIABLES_LOADED" then
		if TinkOptions.TAnchor == nil then
			TinkOptions.TAnchor = "CENTER";
		end
		if TinkOptions.X == nil then
			TinkOptions.X = 0;
		end		
		if TinkOptions.Y == nil then
			TinkOptions.Y = 0;
		end	
		TinkFrame:SetPoint(TinkOptions.TAnchor,TinkOptions.X,TinkOptions.Y)
	end
end)
myFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
myFrame:RegisterEvent("VARIABLES_LOADED")

TinkFrame = CreateFrame("Frame", "TinkFrame", UIParent)
TinkFrame:SetWidth(128)
TinkFrame:SetHeight(128)
TinkFrame:SetFrameStrata("BACKGROUND")
TinkFrame:SetMovable(true)

TinkTip = CreateFrame("Frame", "TinkTip", TinkFrame)
TinkTip:SetWidth(128)
TinkTip:SetHeight(128)
TinkTip:SetFrameStrata("BACKGROUND")
TinkTip:SetPoint("CENTER",0,85)
TinkTip:Hide()

local TipText = TinkTip:CreateFontString(nil, "OVERLAY"); 
TipText:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE") 
TipText:SetPoint("CENTER", TinkTip, "CENTER", 0, -2); 
TipText:SetText(""); 

TinkTipTex = TinkTip:CreateTexture(nil,"BACKGROUND")
TinkTipTex:SetTexture("interface\\AddOns\\Tinker\\tip")
TinkTipTex:SetAllPoints(TinkTip)
TinkTip.texture = TinkTipTex;

TinkBut = CreateFrame("Button", "TinkBut", TinkFrame,"SecureActionButtonTemplate")
TinkBut:SetWidth(48);
TinkBut:SetHeight(48);
TinkBut:SetFrameStrata("BACKGROUND")
TinkBut:SetPoint("CENTER")

TinkTex = TinkBut:CreateTexture(nil,"BACKGROUND")
TinkTex:SetTexture("interface\\AddOns\\Tinker\\Tinker")
TinkTex:SetAllPoints(TinkBut)
TinkBut.texture = TinkTex;

TinkMote = CreateFrame("Button", "TinkMote", TinkFrame,"SecureActionButtonTemplate")
TinkMote:SetWidth(32);
TinkMote:SetHeight(32);
TinkMote:SetFrameStrata("BACKGROUND")
TinkMote:SetPoint("CENTER",0,50)
TinkMote:Hide()
TinkMote:SetScript("OnEnter", function() 
TipText:SetText("Mote Extractor"); 
TinkTip:Show()
end)
TinkMote:SetScript("OnLeave", function() 
TipText:SetText(""); 
TinkTip:Hide()
end)

TinkMoteTex = TinkMote:CreateTexture(nil,"BACKGROUND")
TinkMoteTex:SetTexture("interface\\AddOns\\Tinker\\mote")
TinkMoteTex:SetAllPoints(TinkMote)
TinkMote.texture = TinkMoteTex;

TinkBoots = CreateFrame("Button", "TinkBoots", TinkFrame,"SecureActionButtonTemplate")
TinkBoots:SetWidth(32);
TinkBoots:SetHeight(32);
TinkBoots:SetFrameStrata("BACKGROUND")
TinkBoots:SetPoint("CENTER",-38,38)
TinkBoots:Hide()
TinkBoots:SetScript("OnEnter", function() 
local startTime, duration, enable = GetItemCooldown(GetInventoryItemID("player", 8))
if duration > 0 then
	local seconds = GetTime();
	local cd = math.floor((startTime + duration) - seconds)
	TipText:SetText("Rocket Boots (" .. cd .. "s)"); 
else
	TipText:SetText("Rocket Boots"); 
end
TinkTip:Show()

end)
TinkBoots:SetScript("OnLeave", function() 
TipText:SetText(""); 
TinkTip:Hide()
end)

TinkBootsTex = TinkBoots:CreateTexture(nil,"BACKGROUND")
TinkBootsTex:SetTexture("interface\\AddOns\\Tinker\\rocketboots")
TinkBootsTex:SetAllPoints(TinkBoots)
TinkBoots.texture = TinkBootsTex;

TinkCape = CreateFrame("Button", "TinkCape", TinkFrame,"SecureActionButtonTemplate")
TinkCape:SetWidth(32);
TinkCape:SetHeight(32);
TinkCape:SetFrameStrata("BACKGROUND")
TinkCape:SetPoint("CENTER",38,38)
TinkCape:Hide()
TinkCape:SetScript("OnEnter", function() 
local startTime, duration, enable = GetItemCooldown(GetInventoryItemID("player", 15))
if duration > 0 then
	local seconds = GetTime();
	local cd = math.floor((startTime + duration) - seconds)
	TipText:SetText("Parachute (" .. cd .. "s)"); 
else
	TipText:SetText("Parachute"); 
end
TinkTip:Show()
end)
TinkCape:SetScript("OnLeave", function() 
TipText:SetText(""); 
TinkTip:Hide()
end)

TinkCapeTex = TinkCape:CreateTexture(nil,"BACKGROUND")
TinkCapeTex:SetTexture("interface\\AddOns\\Tinker\\cape")
TinkCapeTex:SetAllPoints(TinkCape)
TinkCape.texture = TinkCapeTex;

TinkJeeves = CreateFrame("Button", "TinkJeeves", TinkFrame,"SecureActionButtonTemplate")
TinkJeeves:SetWidth(32);
TinkJeeves:SetHeight(32);
TinkJeeves:SetFrameStrata("BACKGROUND")
TinkJeeves:SetPoint("CENTER",-50,0)
TinkJeeves:Hide()
TinkJeeves:SetScript("OnEnter", function() 
local startTime, duration, enable = GetItemCooldown("Jeeves")
if duration > 0 then
	local seconds = GetTime();
	local cd = math.floor(((startTime + duration) - seconds) / 60)
	TipText:SetText("Jeeves (" .. cd .. "m)"); 
else
	TipText:SetText("Jeeves"); 
end
TinkTip:Show()
end)
TinkJeeves:SetScript("OnLeave", function() 
TipText:SetText(""); 
TinkTip:Hide()
end)

TinkJeevesTex = TinkJeeves:CreateTexture(nil,"BACKGROUND")
TinkJeevesTex:SetTexture("interface\\AddOns\\Tinker\\jeeves")
TinkJeevesTex:SetAllPoints(TinkJeeves)
TinkJeeves.texture = TinkJeevesTex;

TinkMolle = CreateFrame("Button", "TinkMolle", TinkFrame,"SecureActionButtonTemplate")
TinkMolle:SetWidth(32);
TinkMolle:SetHeight(32);
TinkMolle:SetFrameStrata("BACKGROUND")
TinkMolle:SetPoint("CENTER",50,0)
TinkMolle:Hide()
TinkMolle:SetScript("OnEnter", function() 
local startTime, duration, enable = GetItemCooldown("MOLL-E")
if duration > 0 then
	local seconds = GetTime();
	local cd = math.floor(((startTime + duration) - seconds) / 60)
	TipText:SetText("MOLL-E (" .. cd .. "m)"); 
else
	TipText:SetText("MOLL-E"); 
end
TinkTip:Show()
end)
TinkMolle:SetScript("OnLeave", function() 
TipText:SetText(""); 
TinkTip:Hide()
end)

TinkMolleTex = TinkMolle:CreateTexture(nil,"BACKGROUND")
TinkMolleTex:SetTexture("interface\\AddOns\\Tinker\\molle")
TinkMolleTex:SetAllPoints(TinkMolle)
TinkMolle.texture = TinkMolleTex;

TinkScrap = CreateFrame("Button", "TinkScrap", TinkFrame,"SecureActionButtonTemplate")
TinkScrap:SetWidth(32);
TinkScrap:SetHeight(32);
TinkScrap:SetFrameStrata("BACKGROUND")
TinkScrap:SetPoint("CENTER",38,-38)
TinkScrap:Hide()
TinkScrap:SetScript("OnEnter", function() 
local startTime, duration, enable = GetItemCooldown("Scrapbot Construction Kit")
if duration > 0 then
	local seconds = GetTime();
	local cd = math.floor(((startTime + duration) - seconds) / 60)
	TipText:SetText("Scrapbot (" .. cd .. "m)"); 
else
	TipText:SetText("Scrapbot"); 
end
TinkTip:Show()
end)
TinkScrap:SetScript("OnLeave", function() 
TipText:SetText(""); 
TinkTip:Hide()
end)

TinkScrapTex = TinkScrap:CreateTexture(nil,"BACKGROUND")
TinkScrapTex:SetTexture("interface\\AddOns\\Tinker\\scrapbot")
TinkScrapTex:SetAllPoints(TinkScrap)
TinkScrap.texture = TinkScrapTex;

TinkWormNorth = CreateFrame("Button", "TinkWormNorth", TinkFrame,"SecureActionButtonTemplate")
TinkWormNorth:SetWidth(32);
TinkWormNorth:SetHeight(32);
TinkWormNorth:SetFrameStrata("BACKGROUND")
TinkWormNorth:SetPoint("CENTER",0,-50)
TinkWormNorth:Hide()
TinkWormNorth:SetScript("OnEnter", function() 
local startTime, duration, enable = GetItemCooldown("Wormhole Generator: Northrend")
if duration > 0 then
	local seconds = GetTime();
	local cd = math.floor(((startTime + duration) - seconds) / 60)
	TipText:SetText("Wormhole (" .. cd .. "m)"); 
else
	TipText:SetText("Wormhole"); 
end
TinkTip:Show()
end)
TinkWormNorth:SetScript("OnLeave", function() 
TipText:SetText(""); 
TinkTip:Hide()
end)

TinkWormNTex = TinkWormNorth:CreateTexture(nil,"BACKGROUND")
TinkWormNTex:SetTexture("interface\\AddOns\\Tinker\\wormholenorth")
TinkWormNTex:SetAllPoints(TinkWormNorth)
TinkWormNorth.texture = TinkWormNTex;

TinkKnife = CreateFrame("Button", "TinkKnife", TinkFrame,"SecureActionButtonTemplate")
TinkKnife:SetWidth(32);
TinkKnife:SetHeight(32);
TinkKnife:SetFrameStrata("BACKGROUND")
TinkKnife:SetPoint("CENTER",-38,-38)
TinkKnife:Hide()
TinkKnife:SetScript("OnEnter", function() 
local startTime, duration, enable = GetItemCooldown("Gnomish Army Knife")
if duration > 0 then
	local seconds = GetTime();
	local cd = math.floor(((startTime + duration) - seconds) / 60)
	TipText:SetText("Army Knife (" .. cd .. "m)"); 
else
	TipText:SetText("Army Knife"); 
end
TinkTip:Show()
end)
TinkKnife:SetScript("OnLeave", function() 
TipText:SetText(""); 
TinkTip:Hide()
end)

TinkKnifeTex = TinkKnife:CreateTexture(nil,"BACKGROUND")
TinkKnifeTex:SetTexture("interface\\AddOns\\Tinker\\armyknife")
TinkKnifeTex:SetAllPoints(TinkKnife)
TinkKnife.texture = TinkKnifeTex;

local TinkButAni=TinkBut:CreateAnimationGroup()
local TinkAni2=TinkButAni:CreateAnimation("Rotation")
TinkAni2:SetDuration(10)
TinkAni2:SetDegrees(360)
TinkButAni:SetLooping("REPEAT")
TinkButAni:Play()

TinkBut:SetScript("OnMouseDown", function() 

local scale = TinkBut:GetScale()
if arg1 == "LeftButton" then
	if scale == 1 then
		TinkBut:SetScale(1.5)
		TinkMote:Show()
		TinkBoots:Show()
		TinkCape:Show()
		TinkJeeves:Show()
		TinkMolle:Show()
		TinkScrap:Show()
		TinkWormNorth:Show()
		TinkKnife:Show()
	else 
		TinkBut:SetScale(1)
		TinkMote:Hide()
		TinkBoots:Hide()
		TinkCape:Hide()
		TinkJeeves:Hide()
		TinkMolle:Hide()
		TinkScrap:Hide()
		TinkWormNorth:Hide()
		TinkKnife:Hide()		
	end
end
if arg1 == "RightButton" then 
	TinkFrame:StartMoving(); TinkFrame.isMoving = true; 
end

end)

TinkBut:SetScript("OnMouseUp", function() 
if ( TinkFrame.isMoving ) then 
	TinkFrame:StopMovingOrSizing(); 
	TinkFrame.isMoving = false; 
	local point, relativeTo, relativePoint, xOfs, yOfs = TinkFrame:GetPoint();
	TinkOptions.X = xOfs;
	TinkOptions.Y = yOfs;
	TinkOptions.TAnchor = relativePoint;	
end 
end)

TinkMote:SetAttribute("type", "macro")
TinkMote:SetAttribute("macrotext", "/use Zapthrottle Mote Extractor")

TinkBoots:SetAttribute("type", "macro")
TinkBoots:SetAttribute("macrotext", "/use 8")

TinkCape:SetAttribute("type", "macro")
TinkCape:SetAttribute("macrotext", "/use 15")

TinkJeeves:SetAttribute("type", "macro")
TinkJeeves:SetAttribute("macrotext", "/use Jeeves")

TinkMolle:SetAttribute("type", "macro")
TinkMolle:SetAttribute("macrotext", "/use MOLL-E")

TinkScrap:SetAttribute("type", "macro")
TinkScrap:SetAttribute("macrotext", "/use Scrapbot Construction Kit")

TinkWormNorth:SetAttribute("type", "macro")
TinkWormNorth:SetAttribute("macrotext", "/use Wormhole Generator: Northrend")

TinkKnife:SetAttribute("type", "macro")
TinkKnife:SetAttribute("macrotext", "/use Gnomish Army Knife")

if TinkOptions.TAnchor == nil then
	TinkOptions.TAnchor = "CENTER";
end
if TinkOptions.X == nil then
	TinkOptions.X = 0;
end		
if TinkOptions.Y == nil then
	TinkOptions.Y = 0;
end	

TinkFrame:SetPoint(TinkOptions.TAnchor,TinkOptions.X,TinkOptions.Y)